## mrd6-2013-11-30-c805eb33255dbc0b6647d463c6c67d1c9d3105a0.tar.bz2

=== src/Makefile ===
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include Makefile.options
endif
endif

CXX ?= g++

PLATFORM ?= OS_OTHER
SUPPORT_MODULES ?= yes
TARGET ?= mrd
PREFIX ?= /usr/local
STATIC_STDCXX ?= no
FULL_STATIC ?= no
NO_INLINE ?= no
OBJ_DIR ?= build

DEPS_DIR = $(OBJ_DIR)/.deps
MRD_VERSION_CPP = $(OBJ_DIR)/mrd.version.cpp
MODULES_CPP = $(OBJ_DIR)/modules.cpp

STATIC_MODULES ?= MLD PIM CONSOLE

KERNEL = $(shell uname -s)
ifeq ($(KERNEL),Linux)
	PLATFORM = OS_LINUX
endif
ifneq (,$(findstring BSD,$(KERNEL)))
	PLATFORM = OS_BSD
endif

ifeq ($(FULL_STATIC),yes)
	SUPPORT_MODULES = no
	LDCMD = -static
endif

ifeq ($(SUPPORT_MODULES),yes)
	MODULES ?= BGP
	LDCMD = -rdynamic
	LDMODCMD = -Wl,--as-needed
else
	MODULE_OPTIONS += MRD_NO_DYNAMIC_MODULE_LOADING
endif

INCLUDES = -I../include

NOW = $(shell date -u)

SOURCES = address.cpp address_set.cpp group.cpp icmp_inet6.cpp icmp.cpp \
	  interface.cpp ks_mfa.cpp log.cpp mfa.cpp mrd.cpp mrib.cpp node.cpp \
	  parser.cpp rib.cpp router.cpp timers.cpp support/objpool.cpp \
	  support/ptree.cpp

ifneq ($(shell $(CXX) -c test_dl_inclusion_in_libc.cpp 1>/dev/null 2>&1 ; echo $$? ; rm -f test_dl_inclusion_in_libc.o),0)
LDFLAGS += -ldl # mrd.cpp requires dl* functions
endif

ifeq ($(PLATFORM),OS_LINUX)
	SOURCES += linux/us_mfa.cpp linux/linux_icmp_raw.cpp \
		   linux/linux_unicast_route.cpp linux/mrd_components.cpp
		   
ifeq (,$(findstring LINUX_NO_TRANSLATOR,$(MODULE_OPTIONS)))
	SOURCES += linux/translator.cpp
endif
endif

ifeq ($(PLATFORM),OS_BSD)
	SOURCES += bsd/bsd_rib.cpp bsd/mrd_components.cpp
endif

MLD_SOURCES = mld/mld_def.cpp mld/mld_router.cpp mld/mld_conf.cpp mld/mld_module.cpp
PIM_SOURCES = pim/pim_def.cpp pim/pim_router.cpp pim/pim_interface.cpp \
	      pim/pim_group.cpp pim/pim_source.cpp pim/pim_oif.cpp \
	      pim/pim_neighbour.cpp pim/pim_conf.cpp pim/pim_bsr.cpp \
	      pim/pim_module.cpp
CONSOLE_SOURCES = console/console.cpp console/telnet_console.cpp \
		  console/unix_console.cpp
BGP_SOURCES = bgp/bgp.cpp bgp/bgp_def.cpp
MSNIP_SOURCES = msnip/msnip_module.cpp
MRDISC_SOURCES = mrdisc/mrdisc_module.cpp
RIPNG_SOURCES = ripng/ripng.cpp
ZEBRA_SOURCES = zebra/zebra.cpp
MLD_EXT_SOURCES = mld/mld_def.cpp mld/mld_router.cpp mld/mld_conf.cpp \
		  extra/mld_ext.cpp

TEST_SOURCES = $(SOURCES) no-modules.cpp $(MRD_VERSION_CPP)
MRD_SOURCES = $(SOURCES) main.cpp $(MODULES_CPP) $(MRD_VERSION_CPP)

# used to build object list
ALL_SOURCES = $(SOURCES) main.cpp $(MRD_SOURCES) $(MLD_SOURCES) \
	      $(PIM_SOURCES) $(CONSOLE_SOURCES) $(BGP_SOURCES) \
	      $(MSNIP_SOURCES) $(MRDISC_SOURCES) $(RIPNG_SOURCES) \
	      $(ZEBRA_SOURCES)

# used in dependency generation
BUILT_SOURCES = $(SOURCES) main.cpp

MLD_TARGET	= mld.so
PIM_TARGET	= pim.so
CONSOLE_TARGET	= console.so
BGP_TARGET	= bgp.so
MSNIP_TARGET	= msnip.so
MRDISC_TARGET	= mrdisc.so
RIPNG_TARGET	= ripng.so
ZEBRA_TARGET	= zebra.so
MLD_EXT_TARGET	= mld_ext.so

EXTERNAL_MODULES = $(foreach module,$(MODULES),$($(module)_TARGET))

TESTS = tests/address_unittest tests/ptree_unittest tests/mrib_unittest

DEST_PREFIX = $(DESTDIR)$(PREFIX)

CXXFLAGS += $(CPPFLAGS) $(INCLUDES) -ansi -Wall -Wno-multichar -fno-exceptions -fPIC \
	   -fno-strict-aliasing -D$(PLATFORM) $(addprefix -D,$(MODULE_OPTIONS))

ifeq ($(OPTIMIZE),yes)
	ifeq ($(SPACE_OPTIMIZE),yes)
		CXXFLAGS += -O3 -Os
	else
		CXXFLAGS += -O3
	endif
else
	CXXFLAGS += -g
	ifeq ($(NO_INLINE),yes)
		CXXFLAGS += -O0 -fno-inline
	else
		CXXFLAGS += -O2
	endif
endif

LDFLAGS += -lm
LDCMD += -Wl,--as-needed

ifeq ($(STATIC_STDCXX),no)
	LDFLAGS += -lstdc++
else
	LDFLAGS += `$(CXX) -print-file-name=libstdc++.a`
endif

TEST_OBJECTS = $(addprefix $(OBJ_DIR)/,$(TEST_SOURCES:.cpp=.o))
MRD_OBJECTS = $(addprefix $(OBJ_DIR)/,$(MRD_SOURCES:.cpp=.o))

all: $(TARGET) $(EXTERNAL_MODULES)

define module_template
BUILT_SOURCES += $$($(1)_SOURCES)
$$($(1)_TARGET): $$(addprefix $(OBJ_DIR)/,$($(1)_SOURCES:.cpp=.o))
	@echo "Module $$($(1)_TARGET)"
	@$(CXX) -shared $(LDMODCMD) $(CXXFLAGS) -o $$($(1)_TARGET) \
		$$(addprefix $(OBJ_DIR)/,$($(1)_SOURCES:.cpp=.o)) $(LDFLAGS)
endef

define static_module_template
BUILT_SOURCES += $$($(1)_SOURCES)
MRD_OBJECTS += $$(addprefix $(OBJ_DIR)/,$($(1)_SOURCES:.cpp=.o))
endef

define unittest_template
BUILT_SOURCES += $(1).cpp
$(1): $(TEST_OBJECTS) $(1).cpp
	@echo "Linking $(1)"
	@$(CXX) $(LDCMD) $(CXXFLAGS) -o $(1) $(1).cpp $(TEST_OBJECTS) \
		$(LDFLAGS) -lboost_unit_test_framework
endef

# generate the required build rules for each module
$(foreach module,$(MODULES),$(eval $(call module_template,$(module))))
$(foreach module,$(STATIC_MODULES),$(eval $(call static_module_template,$(module))))
# generate the required build rules for each unit test
$(foreach test,$(TESTS),$(eval $(call unittest_template,$(test))))

$(TARGET): $(MRD_OBJECTS)
	@echo "Linking $(TARGET)"
	@$(CXX) $(LDCMD) $(CXXFLAGS) -o $@ $(MRD_OBJECTS) $(LDFLAGS)

install: $(TARGET) $(EXTERNAL_MODULES)
	install -D $(TARGET) $(DEST_PREFIX)/sbin/$(TARGET)
	install -D ../tools/mrd6sh $(DEST_PREFIX)/bin/mrd6sh
ifneq (,$(EXTERNAL_MODULES))
	mkdir -p $(DEST_PREFIX)/lib/mrd6/
	cp $(EXTERNAL_MODULES) $(DEST_PREFIX)/lib/mrd6/
endif

$(MRD_VERSION_CPP): $(SOURCES) Makefile Makefile.options
	@set -e; mkdir -p $(dir $@); \
		echo '/* This file is automatically generated */' > $(MRD_VERSION_CPP); \
		echo 'const char *BuildDate = "$(NOW)";' >> $(MRD_VERSION_CPP)

$(MODULES_CPP): Makefile Makefile.options
	@set -e; mkdir -p $(dir $@); \
		echo "Generating modules.cpp"; \
		scripts/generate-modules-cpp.pl $(STATIC_MODULES) > $(MODULES_CPP)

.PHONY: tests
tests: $(TESTS)

OPTIONS = Makefile.options

$(OPTIONS):
	@touch $@

$(DEPS_DIR)/%.d: %.cpp $(OPTIONS)
	@echo "Deps $<"
	@set -e; mkdir -p $(dir $@); \
		$(CXX) -MM -MT $@ -MT $(addprefix $(OBJ_DIR)/,$(<:.cpp=.o)) \
		       $(CXXFLAGS) $< > $@

DEPENDENCIES = $(addprefix $(DEPS_DIR)/,$(BUILT_SOURCES:.cpp=.d))

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
	-include $(DEPENDENCIES)
endif
endif

$(OBJ_DIR)/%.o: %.cpp $(OPTIONS)
	@echo "C++ $<"
	@set -e; mkdir -p $(dir $@); \
		$(CXX) -c $(CXXFLAGS) $< -o $@

clean:
	rm -rf $(TARGET) $(TESTS) $(EXTERNAL_MODULES) \
		$(addprefix $(OBJ_DIR)/,$(ALL_SOURCES:.cpp=.o))

distclean: clean
	rm -rf $(DEPS_DIR) $(MRD_VERSION_CPP) $(MODULES_CPP)

.PHONY: install clean distclean

=== debian/changelog ===
mrd6 (0.9.6-2) unstable; urgency=low

  * Now really fix S390 building issues (Closes: #455280)

 -- Hugo Santos <hugo@fivebits.net>  Fri,  4 Jul 2008 14:59:21 +0200

mrd6 (0.9.6-1) unstable; urgency=low

  * New upstream release.

 -- Hugo Santos <hugo@fivebits.net>  Fri,  4 Jul 2008 14:59:21 +0200

mrd6 (0.9.5-rev3.dfsg-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Repackage upstream tarball to remove non-free IETF RFC/I-D (Closes: #423063)
  * Really fix FTBFS with GCC 4.3 (Closes: #417436)
  * Clean up debian/rules and create debian/{examples,manpages}

 -- Lior Kaplan <kaplan@debian.org>  Sat, 09 Jun 2007 00:57:01 +0300

mrd6 (0.9.5-rev3-0.1) unstable; urgency=low

  * Non-maintainer upload. (Closes: #418074)
  * New maintainer. (Closes: #418084)
    - Adopt this package by its upstream, which works on it very tightly with 
      Debian. Thank you Hugo for covering for an MIA maintainer.
  * New upstream release
    - Fix segfault when unloading module (Closes: #394590)
    - Fix FTBFS with GCC 4.3 (Closes: #417436)
    - New upstream address (Closes: #411805)
    - Change the package's version number inside debian, so it will be more
      accurate and easy to maintain with future (debian & upstream) versions.
  * debian/control:
    - Bump standards version to 3.7.2.2 (no changes needed)
    - Remove extra build depends, as they are covered by build-essential.
    - Update package description according to the README file.
    - Change maintainer to Hugo Santos.
  * Add watch file.

 -- Lior Kaplan <kaplan@debian.org>  Mon, 09 Apr 2007 20:28:32 +0300

mrd6 (0.9.5-release-1) unstable; urgency=low

  * New upstream release
  * Hack the version number so we can upgrade properly
  * New features:
        - update to draft 06
        - implements MSNIP and MRDISC
        - improved user-space forwarding on Linux

 -- Anand Kumria <wildfire@progsoc.org>  Sun,  8 Jan 2006 12:28:48 +1100

mrd6 (0.9.5-pre2-1) unstable; urgency=low

  * New upstream (pre)release

 -- Anand Kumria <wildfire@progsoc.org>  Mon, 28 Nov 2005 15:41:11 +1100

mrd6 (0.9.5-pre1-1) unstable; urgency=low

  * Initial upload to Debian

 -- Anand Kumria <wildfire@progsoc.org>  Tue, 15 Nov 2005 11:05:57 +1100

mrd6 (0.9.4-beta2-1) unstable; urgency=low

  * beta2

 -- Hugo Santos <hsantos@av.it.pt>  Mon, 17 Oct 2005 22:57:45 +0100

mrd6 (0.9.4-beta1-1) unstable; urgency=low

  * Bumped to 0.9.4-beta1

 -- Hugo Santos <hsantos@av.it.pt>  Wed, 28 Sep 2005 01:11:03 +0100

mrd6 (0.9.2-beta3-1) unstable; urgency=low

  * beta3

 -- Hugo Santos <hsantos@av.it.pt>  Tue, 23 Aug 2005 23:36:40 +0100

mrd6 (0.9.2-beta2-1) unstable; urgency=low

  * beta2

 -- Hugo Santos <hsantos@av.it.pt>  Thu, 18 Aug 2005 00:09:07 +0100

mrd6 (0.9.2-beta1-1) unstable; urgency=low

  * Bumped to 0.9.2.

 -- Hugo Santos <hsantos@av.it.pt>  Fri, 12 Aug 2005 00:30:29 +0100

mrd6 (0.9.1-beta2-1) unstable; urgency=low

  * Version bump

 -- Hugo Santos <hsantos@av.it.pt>  Mon, 25 Jul 2005 00:32:34 +0100

mrd6 (0.9.1-beta1-1) unstable; urgency=low

  * Version bump

 -- Hugo Santos <hsantos@av.it.pt>  Thu,  7 Jul 2005 02:34:26 +0100

mrd6 (0.9-beta2) unstable; urgency=low

  * Beta 2

 -- Hugo Santos <hsantos@av.it.pt>  Thu, 30 Jun 2005 06:19:51 +0100

mrd6 (0.9-beta1) unstable; urgency=low

  * Bump to 0.9

 -- Hugo Santos <hsantos@av.it.pt>  Sat, 25 Jun 2005 20:07:24 +0100

mrd6 (0.8.5-beta1-1) unstable; urgency=low

  * Bumped to 0.8.5

 -- Hugo Santos <hsantos@av.it.pt>  Sat, 30 Apr 2005 21:55:09 +0100

mrd6 (0.8-beta2-1) unstable; urgency=low

  * Yet another bump. 0.8-beta2

 -- Hugo Santos <hsantos@av.it.pt>  Sat, 23 Apr 2005 03:06:53 +0100

mrd6 (0.8-beta1-1) unstable; urgency=low

  * Bumped version to 0.8-beta1

 -- Hugo Santos <hsantos@av.it.pt>  Tue, 19 Apr 2005 23:34:04 +0100

mrd6 (0.7-beta3-1) unstable; urgency=low

  * Bumped version to 0.7-beta3

 -- Hugo Santos <hsantos@av.it.pt>  Tue,  5 Apr 2005 02:08:32 +0100

mrd6 (0.7-beta2-1) unstable; urgency=low

  * Bumped version to 0.7-beta2

 -- Hugo Santos <hsantos@av.it.pt>  Thu, 26 Mar 2005 03:46:26 +0000

mrd6 (0.7-beta1-1) unstable; urgency=low

  * Bumped version to 0.7-beta1

 -- Hugo Santos <hsantos@av.it.pt>  Thu, 24 Mar 2005 14:52:00 +0000

mrd6 (0.6-beta6-1) unstable; urgency=low

  * Bumped version to beta6

 -- Hugo Santos <hsantos@av.it.pt>  Sun,  7 Mar 2005 23:13:08 +0000

mrd6 (0.6-beta5-1) unstable; urgency=low

  * Initial Release.

 -- Hugo Santos <hsantos@av.it.pt>  Sun,  27 Feb 2005 03:08:08 +0000

=== debian/control ===
Source: mrd6
Section: net
Priority: optional
Maintainer: Hugo Santos <hugo@fivebits.net>
Build-Depends: debhelper (>= 5.0.0), perl
Standards-Version: 3.7.3
Homepage: http://fivebits.net/proj/mrd6/

Package: mrd6
Architecture: any
Depends: ${shlibs:Depends}, lsb-base
Description: IPv6 Multicast Routing Daemon
 mrd6 is a modular IPv6 Multicast Routing Daemon which implements:
   * MLDv1 and MLDv2 support
     - MLD proxying
   * PIM-SM (ASM and SSM)
     - Bootstrap (BSR) Mechanism support
     - Static RP configuration
     - Embedded-RP support (RFC 3956)
   * partial MBGP support
     - Implements basic BGP4 mechanisms (IPv6 Multicast SAFI)
       to update local MRIB from MBGP info
     - Uses IPv6 Multicast SAFI prefixes announced by
       peers to update local MRIB
     - Is able to announce local prefixes
     - Filter support
   * Supports both native and virtual (tunnel) interfaces
     (tested IPv6-IPv4, IPv6-IPv6 and TUN/TAP tunnels)
   * Abstract Forwarding Interface (MFA) with user-space module
   * Remote configuration and online administration
 .
 Homepage: http://fivebits.net/proj/mrd6/

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

TARGET = mrd6
DESTDIR = $(CURDIR)/debian/mrd6

export TARGET DESTDIR

configure: configure-stamp

configure-stamp:
	dh_testdir

	config/base.pl \
		--prefix /usr \
		--static mld \
		--static pim \
		--static console \
		--external bgp \
		--external msnip \
		--external mrdisc \

	touch configure-stamp

build: build-stamp

build-stamp: configure
	dh_testdir

	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	[ ! -f Makefile ] || $(MAKE) clean
	rm -rf src/build/
	rm -f src/Makefile.options
	rm -f build-stamp configure-stamp

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
#	dh_install
	dh_installinit
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
